<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META NAME="generator" CONTENT="http://txt2tags.org">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf8">
<LINK REL="stylesheet" TYPE="text/css" HREF="../../style/style.css">
</HEAD><BODY BGCOLOR="white" TEXT="black">
<CENTER>
</CENTER>


<H1>Bashes numéricas no BASh</H1>

<P>
<B><I>Colaboração: Paulo Roberto Bagatini</I></B>
</P>
<P>
<B><I>Data de Publicação: 19 de fevereiro de 2013</I></B>
</P>
<P>
Umas das capacidades inatas do <A HREF="http://linux.die.net/man/1/bash">BASh</A>,
um dos shell texto mais usados, é a manipulação de números em bases
numéricas outras que não a decimal.
</P>

<H2>Conversão de uma base qualquer para decimal</H2>

<PRE>
  $ echo $((844)) # decimal
  844
  
  $ echo $((0x34c)) # hexadecimal
  844
  
  $ echo $((01514)) # octal
  844
  
  $ echo $((2#1101001100)) # binario
  844
  
  $ echo $((21#1j4)) # base 21 -&gt; QUALQUER BASE!
  844
</PRE>

<H2>Operações com números em várias bases numéricas</H2>

<PRE>
  $ echo $(( 2#1101001100 * 0x34c + 21#1j4)) # 844 * 844 + 844
  713180
</PRE>

<H2>Conversão de decimal para outras bases</H2>

<P>
A conversão de decimal para outras bases não é tão "nativa".
Então, naturalmente, existem várias formas de fazer.
Aqui vão algumas sugestões, priorizando o <B>não uso</B> de loops.
</P>

<PRE>
  $ dec=844
  
  $ printf '%x\n' $dec # para hexadecimal
  34c
  
  $ printf '%X\n' $dec
  34C
  
  $ printf '%o\n' $dec # para octal
  1514
  
  $ bc &lt;&lt;&lt; "obase=2;$dec" # para binario
  1101001100
  
  $ bc &lt;&lt;&lt; "obase=21;$dec" # para base 21 -&gt; QUALQUER BASE!
   01 19 04
  
  $ # usando letras como digitos para bases maiores que 10
  $ eval echo -e $(bc &lt;&lt;&lt; "obase=21;$dec" | sed -r 's/ [1-9][0-9]/\\\\x$(printf %x $((&amp;-9+96)))/g;s/ 0//g')
  1j4
</PRE>

<H2>Conversão de uma base qualquer (ibase&lt;=16) para outra base qualquer (obase&lt;=2.147.483.647 :-p)</H2>

<PRE>
  $ bc &lt;&lt;&lt; "obase=16;ibase=2;1101001100"
  34C
  
  $ bc &lt;&lt;&lt; "ibase=2;obase=1010;11" # cuidado com a ordem das variáveis ibase e obase ;-)
  3
</PRE>

<H2>Código ascii decimal para caracter (chr)</H2>

<PRE>
  $ echo -e \\x$(printf %x 65)
  A
</PRE>

<H2>Caracter para código ascii decimal (ord)</H2>

<PRE>
  $ echo -n A | od -td1 | grep -Eo " [0-9]+"
   65
</PRE>

<H2>Caracter para código ascii hexadecimal no uso em URL's</H2>

<PRE>
  $ string='http://uma_url/~user/index.html?parm1=VAL1&amp;parm2=ã-ç'
  
  $ echo -n "$string" | od -tx1 | grep -Eo "( ..)+$" | tr " a-z" "%A-Z" | tr -d "\n"; echo
  %68%74%74%70%3A%2F%2F%75%6D%61%5F%75%72%6C%2F%7E%75%73%65%72%2F%69%6E%64%65%78%2E%68%74%6D%6C%3F%70%61%72%6D%31%3D%56%41%4C%31%26%70%61%72%6D%32%3D%C3%A3%2D%C3%A7
</PRE>

<H2>Caracter especiais (diferentes de [a-zA-Z0-9-._~-]) para código ascii hexadecimal no uso em URL's</H2>

<PRE>
  $ eval echo $(sed -r 's/[^A-Za-z0-9._~-]/$(echo -n "\\&amp;" | od -tx1 | grep -Eo "( ..)+$" | tr " a-z" "%A-Z")/g;s/\\([^\\"])/\1/g' &lt;&lt;&lt; $string)
  http%3A%2F%2Fuma_url%2F~user%2Findex.html%3Fparm1%3DVAL1%26parm2%3D%C3%A3-%C3%A7
</PRE>

<H2>Cuidado com ambientes com suporte a Unicode</H2>

<PRE>
  $ echo -n A | od -tx1 | grep -Eo " ..+"
   41
  
  $ echo -n Ç | od -tx1 | grep -Eo " ..+"
   c3 87
  
  $ echo -n Ç | iconv -f utf8 -t latin1 | od -tx1 | grep -Eo " ..+"
   c7
  
  $ echo $((0xc7))
  199
</PRE>

<H2>Comandos usados nesse artigo</H2>

<UL>
<LI><A HREF="http://linux.die.net/man/1/bash">bash</A>
<LI><A HREF="http://linux.die.net/man/1/bc">bc</A>
<LI><A HREF="http://linux.die.net/man/1/echo">echo</A>
<LI><A HREF="http://linux.die.net/man/1/eval">eval</A>
<LI><A HREF="http://linux.die.net/man/1/grep">grep</A>
<LI><A HREF="http://linux.die.net/man/1/iconv">iconv</A>
<LI><A HREF="http://linux.die.net/man/1/od">od</A>
<LI><A HREF="http://linux.die.net/man/1/printf">printf</A>
<LI><A HREF="http://linux.die.net/man/1/sed">sed</A>
<LI><A HREF="http://linux.die.net/man/1/tr">tr</A>
<P></P>
</UL>

<!-- html code generated by txt2tags 2.6 (http://txt2tags.org) -->
<!-- cmdline: txt2tags -t html -\-encoding=utf8 -\-style=../style/style.css dica.t2t -->
</BODY></HTML>
